//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%43595C6202B4.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%43595C6202B4.cm

//## begin module%43595C6202B4.cp preserve=no
//## end module%43595C6202B4.cp

//## Module: RandomGenerator%43595C6202B4; Package specification
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/RandomGenerator.h

#ifndef RANDOMGENERATOR
#define RANDOMGENERATOR 1

//## begin module%43595C6202B4.additionalIncludes preserve=no
//## end module%43595C6202B4.additionalIncludes

//## begin module%43595C6202B4.includes preserve=yes
//## end module%43595C6202B4.includes

// RandomLuxAdapter
#include <XSUtil/Numerics/RandomLuxAdapter.h>
//## begin module%43595C6202B4.declarations preserve=no
//## end module%43595C6202B4.declarations

//## begin module%43595C6202B4.additionalDeclarations preserve=yes
#include <xsTypes.h>
//## end module%43595C6202B4.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    void GaussRand(RealArray& gaussSamples);
    void PoissonRand(RealArray& poissonMeans);
    void UniformRand(RealArray& randomNumbers);
    void CauchyRand(RealArray& randomNumbers);
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    //## begin Numerics::RandomGenerator%43595CED03E0.preface preserve=yes
    //## end Numerics::RandomGenerator%43595CED03E0.preface

    //## Class: RandomGenerator%43595CED03E0; Parameterized Class
    //## Category: XSUtil::Numerics%3F6F5A7603D4
    //## Subsystem: XSUtil::Numerics%41E6D0F3003C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <typename T>
    class RandomGenerator 
    {
      //## begin Numerics::RandomGenerator%43595CED03E0.initialDeclarations preserve=yes
      //## end Numerics::RandomGenerator%43595CED03E0.initialDeclarations

      public:
        //## Destructor (generated)
          ~RandomGenerator();


        //## Other Operations (specified)
          //## Operation: instance%43595EE50128
          static RandomGenerator<T>& instance ();

          //## Operation: initialize%435E88B801F8
          void initialize ();

          //## Operation: getRandom%435EA3AE02F1
          void getRandom (std::vector<Real>& randNumbers) const;

          //## Operation: getRandom%435EA4D30152
          void getRandom (float* randNumbers, int length) const;

          //## Operation: getRandom%435EA55701ED
          void getRandom (Real* randNumbers, int length) const;

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: seed%435E664D015C
          int seed () const;
          void seed (int value);

          //## Attribute: parHooks%435E671A02F4
          const std::vector<Real>& parHooks () const;
          void parHooks (const std::vector<Real>& value);

        // Additional Public Declarations
          //## begin Numerics::RandomGenerator%43595CED03E0.public preserve=yes
          //## end Numerics::RandomGenerator%43595CED03E0.public

      protected:
        //## Constructors (generated)
          RandomGenerator();

        // Additional Protected Declarations
          //## begin Numerics::RandomGenerator%43595CED03E0.protected preserve=yes
          //## end Numerics::RandomGenerator%43595CED03E0.protected

      private:
        //## Constructors (generated)
          RandomGenerator(const RandomGenerator< T > &right);

        //## Assignment Operation (generated)
          RandomGenerator< T > & operator=(const RandomGenerator< T > &right);

        // Additional Private Declarations
          //## begin Numerics::RandomGenerator%43595CED03E0.private preserve=yes
          //## end Numerics::RandomGenerator%43595CED03E0.private

      private: //## implementation
        // Data Members for Class Attributes

          //## begin Numerics::RandomGenerator::seed%435E664D015C.attr preserve=no  public: int {U} 
          int m_seed;
          //## end Numerics::RandomGenerator::seed%435E664D015C.attr

          //## begin Numerics::RandomGenerator::parHooks%435E671A02F4.attr preserve=no  public: std::vector<Real> {U} 
          std::vector<Real> m_parHooks;
          //## end Numerics::RandomGenerator::parHooks%435E671A02F4.attr

          //## Attribute: generator%44EDB6090164
          //## begin Numerics::RandomGenerator::generator%44EDB6090164.attr preserve=no  private: T* {U} 
          T* m_generator;
          //## end Numerics::RandomGenerator::generator%44EDB6090164.attr

        // Additional Implementation Declarations
          //## begin Numerics::RandomGenerator%43595CED03E0.implementation preserve=yes
          //## end Numerics::RandomGenerator%43595CED03E0.implementation

    };

    //## begin Numerics::RandomGenerator%43595CED03E0.postscript preserve=yes
    //## end Numerics::RandomGenerator%43595CED03E0.postscript

    //## begin Numerics::DefaultRandomGenerator%435FCC1202DB.preface preserve=yes
    //## end Numerics::DefaultRandomGenerator%435FCC1202DB.preface

    //## Class: DefaultRandomGenerator%435FCC1202DB; Instantiated Class
    //## Category: XSUtil::Numerics%3F6F5A7603D4
    //## Subsystem: XSUtil::Numerics%41E6D0F3003C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%435FCC980235;RandomLuxAdapter { -> }

    typedef RandomGenerator< Numerics::RandomLuxAdapter  > DefaultRandomGenerator;

    //## begin Numerics::DefaultRandomGenerator%435FCC1202DB.postscript preserve=yes
    //## end Numerics::DefaultRandomGenerator%435FCC1202DB.postscript

    // Parameterized Class Numerics::RandomGenerator 

    //## Get and Set Operations for Class Attributes (inline)

    template <typename T>
    inline int RandomGenerator<T>::seed () const
    {
      //## begin Numerics::RandomGenerator::seed%435E664D015C.get preserve=no
      return m_seed;
      //## end Numerics::RandomGenerator::seed%435E664D015C.get
    }

    template <typename T>
    inline void RandomGenerator<T>::seed (int value)
    {
      //## begin Numerics::RandomGenerator::seed%435E664D015C.set preserve=no
      m_seed = value;
      //## end Numerics::RandomGenerator::seed%435E664D015C.set
    }

    template <typename T>
    inline const std::vector<Real>& RandomGenerator<T>::parHooks () const
    {
      //## begin Numerics::RandomGenerator::parHooks%435E671A02F4.get preserve=no
      return m_parHooks;
      //## end Numerics::RandomGenerator::parHooks%435E671A02F4.get
    }

    template <typename T>
    inline void RandomGenerator<T>::parHooks (const std::vector<Real>& value)
    {
      //## begin Numerics::RandomGenerator::parHooks%435E671A02F4.set preserve=no
      m_parHooks = value;
      //## end Numerics::RandomGenerator::parHooks%435E671A02F4.set
    }

    // Parameterized Class Numerics::RandomGenerator 

    template <typename T>
    RandomGenerator<T>::RandomGenerator()
      //## begin RandomGenerator::RandomGenerator%43595CED03E0_const.hasinit preserve=no
      //## end RandomGenerator::RandomGenerator%43595CED03E0_const.hasinit
      //## begin RandomGenerator::RandomGenerator%43595CED03E0_const.initialization preserve=yes
      //## end RandomGenerator::RandomGenerator%43595CED03E0_const.initialization
    {
      //## begin Numerics::RandomGenerator::RandomGenerator%43595CED03E0_const.body preserve=yes
       m_generator = new T;
      //## end Numerics::RandomGenerator::RandomGenerator%43595CED03E0_const.body
    }


    template <typename T>
    RandomGenerator<T>::~RandomGenerator()
    {
      //## begin Numerics::RandomGenerator::~RandomGenerator%43595CED03E0_dest.body preserve=yes
       // Remember this is a Meyers Singleton.  Destruction must NOT 
       // depend on existence of any other Singletons. 
       delete m_generator; 
      //## end Numerics::RandomGenerator::~RandomGenerator%43595CED03E0_dest.body
    }



    //## Other Operations (implementation)
    template <typename T>
    RandomGenerator<T>& RandomGenerator<T>::instance ()
    {
      //## begin Numerics::RandomGenerator::instance%43595EE50128.body preserve=yes
       // The Meyers variation of the Singleton pattern.
       static RandomGenerator<T> randomGenerator;
       return randomGenerator;
      //## end Numerics::RandomGenerator::instance%43595EE50128.body
    }

    template <typename T>
    void RandomGenerator<T>::initialize ()
    {
      //## begin Numerics::RandomGenerator::initialize%435E88B801F8.body preserve=yes
         m_generator->initialize(m_seed, m_parHooks);
      //## end Numerics::RandomGenerator::initialize%435E88B801F8.body
    }

    template <typename T>
    void RandomGenerator<T>::getRandom (std::vector<Real>& randNumbers) const
    {
      //## begin Numerics::RandomGenerator::getRandom%435EA3AE02F1.body preserve=yes
       m_generator->getRandom(randNumbers, m_parHooks);
      //## end Numerics::RandomGenerator::getRandom%435EA3AE02F1.body
    }

    template <typename T>
    void RandomGenerator<T>::getRandom (float* randNumbers, int length) const
    {
      //## begin Numerics::RandomGenerator::getRandom%435EA4D30152.body preserve=yes
       m_generator->getRandom(randNumbers, length, m_parHooks);
      //## end Numerics::RandomGenerator::getRandom%435EA4D30152.body
    }

    template <typename T>
    void RandomGenerator<T>::getRandom (Real* randNumbers, int length) const
    {
      //## begin Numerics::RandomGenerator::getRandom%435EA55701ED.body preserve=yes
       m_generator->getRandom(randNumbers, length, m_parHooks);
      //## end Numerics::RandomGenerator::getRandom%435EA55701ED.body
    }

    // Additional Declarations
      //## begin Numerics::RandomGenerator%43595CED03E0.declarations preserve=yes
      //## end Numerics::RandomGenerator%43595CED03E0.declarations

} // namespace Numerics

//## begin module%43595C6202B4.epilog preserve=yes
//## end module%43595C6202B4.epilog


#endif
